unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Edit4: TEdit;
    Edit5: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  a,b:Int64;

implementation

{$R *.dfm}


///////       /////////////////
//      TRUE -   
FUNCTION DecoderStr(const st0:string; var a,b:Int64):boolean;
var
n:byte;
BEGIN
n:=pos('/',st0);
if n=0 then
 begin
  DecoderStr:=false;   //  st0 = '-12'
  a:=StrToInt64(st0);
  b:=1;
 end else
 begin
  DecoderStr:=true;    //  st0 = '-12/5'
  a:=StrToInt64(copy(st0,1,n-1));
  b:=StrToInt64(copy(st0,n+1,99));
 end;
END;

///////   /////////////////////////////////////////
//      tmp_a - , tmp_b - 
PROCEDURE Sokr(var tmp_a,tmp_b:Int64);
var
flag:boolean;
BEGIN
if tmp_a mod tmp_b=0 then
 begin                   //  
  tmp_a:=tmp_a div tmp_b;
  tmp_b:=1;
 end else
 begin                   //  
  repeat
   flag:=false;          //  
   if (tmp_a mod 2=0)and(tmp_b mod 2=0) then
    begin
     tmp_a:=tmp_a div 2;
     tmp_b:=tmp_b div 2;
     flag:=true;
    end;
   if (tmp_a mod 3=0)and(tmp_b mod 3=0) then
    begin
     tmp_a:=tmp_a div 3;
     tmp_b:=tmp_b div 3;
     flag:=true;
    end;
   if (tmp_a mod 5=0)and(tmp_b mod 5=0) then
    begin
     tmp_a:=tmp_a div 5;
     tmp_b:=tmp_b div 5;
     flag:=true;
    end;
  until flag=false;
 end;
END;

///////     /////////////////////////////
PROCEDURE Proizv(const st0,st1:string; var a,b:Int64);
var
a0,b0,a1,b1,tmp_a,tmp_b:Int64;
BEGIN
DecoderStr(st0,a0,b0);
DecoderStr(st1,a1,b1);
tmp_a:=a0*a1;
tmp_b:=b0*b1;
Sokr(tmp_a,tmp_b);
a:=tmp_a;
b:=tmp_b;
END;

///////     /////////////////////////////
PROCEDURE Delenie(const st0,st1:string; var a,b:Int64);
var
a0,b0,a1,b1,tmp_a,tmp_b:Int64;
BEGIN
DecoderStr(st0,a0,b0);
DecoderStr(st1,a1,b1);
tmp_a:=a0*b1;
tmp_b:=b0*a1;
Sokr(tmp_a,tmp_b);
a:=tmp_a;
b:=tmp_b;
END;

///////     /////////////////////////////
PROCEDURE Summa(const st0,st1:string; var a,b:Int64);
var
a0,b0,a1,b1,tmp_a,tmp_b:Int64;
BEGIN
DecoderStr(st0,a0,b0);
DecoderStr(st1,a1,b1);
tmp_a:=a0*b1+a1*b0;
tmp_b:=b0*b1;
Sokr(tmp_a,tmp_b);
a:=tmp_a;
b:=tmp_b;
END;

///////       ////////////////////////////////
FUNCTION StrDecoder(const a0,b0:Int64):string;
var
a,b:Int64;
BEGIN
a:=a0;  b:=b0;
if (a<0)and(b<0) then
 begin
  a:=-a;  b:=-b;
 end;
if a mod b=0 then StrDecoder:=inttostr(a div b) else
 StrDecoder:=inttostr(a)+'/'+inttostr(b);
END;




procedure TForm1.Button1Click(Sender: TObject);
begin
Proizv(edit1.Text,edit2.Text,a,b);
Summa(StrDecoder(a,b),edit3.Text,a,b);
label1.Caption:=StrDecoder(a,b);



end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Delenie(edit4.Text,edit5.Text,a,b);
label5.Caption:=StrDecoder(a,b);
end;

end.
